// Adds a pipeline job to jenkins
import jenkins.model.Jenkins
import jenkins.model.BuildDiscarderProperty
import org.jenkinsci.plugins.workflow.job.WorkflowJob
import org.jenkinsci.plugins.workflow.cps.CpsScmFlowDefinition
import org.jenkinsci.plugins.workflow.flow.FlowDefinition
import hudson.plugins.git.GitSCM
import hudson.plugins.git.UserRemoteConfig
import hudson.plugins.git.BranchSpec
import com.cloudbees.hudson.plugins.folder.*
import hudson.model.ParametersDefinitionProperty
import hudson.model.ParameterDefinition
import hudson.model.StringParameterDefinition
import hudson.model.BooleanParameterDefinition
import hudson.tasks.LogRotator

// Bring some values in from ansible using the jenkins_script modules wierd "args" approach (these are not gstrings)
String jobName = "{{ item.name }}"
String gitRepo = "ssh://git@bitbucket.intraservice.corp:7999/{{ lookup('env','BITBUCKET_PROJECT') }}/{{ lookup('env','PIPELINES_REPO') }}-pipelines.git"

Jenkins jenkins = Jenkins.instance 

def folders = {{ job_folders }}
def folder = null 

folders.eachWithIndex { item, index -> 
   if (index == 0) {
        folder = jenkins.getItem(item)
   } else {
        folder = folder.getItem(item)
   }
}

// Create the git configuration
UserRemoteConfig userRemoteConfig = new UserRemoteConfig(gitRepo, "origin", "", "b3-bitbucket")

doGenerateSubmoduleConfigurations = false
submoduleCfg = null
branches = new ArrayList<BranchSpec>()
browser = null
gitTool = null
extensions = []

branches.add(new BranchSpec("{{ item.branch }}"))
GitSCM scm = new GitSCM([userRemoteConfig], branches, doGenerateSubmoduleConfigurations, submoduleCfg, browser, gitTool, extensions)

// Create the workflow
FlowDefinition flowDefinition = (FlowDefinition) new CpsScmFlowDefinition(scm, "{{ item.script_path }}")

// Check if the job already exists
Object job = null
job = folder.getItem(jobName)
if (job == null) {
  oldJob = jenkins.getItem(jobName)
  if (oldJob.getClass() == WorkflowJob.class) {
    // Move any existing job into the folder
    Items.move(oldJob, folder)
  } else {
    // Create it if it doesn't
    job = folder.createProject(WorkflowJob, jobName)
  }
}
// Add the workflow to the job
flowDefinition.setLightweight(true)
job.setDefinition(flowDefinition)

ParametersDefinitionProperty params = job.getProperty(ParametersDefinitionProperty.class);

List<ParameterDefinition> newParams = new ArrayList<>();

//newParams.addAll(params.getParameterDefinitions());

newParams.add(new StringParameterDefinition("branch", "develop", "branch para execução via pipeline", true));

{% for param in item.params %}
{% if param.type == "string" %}
newParams.add(new StringParameterDefinition("{{ param.name }}", "{{ param.default_value }}", "{{ param.description }}", true));
{% elif param.type == "boolean" %}
newParams.add(new BooleanParameterDefinition("{{ param.name }}", "{{ param.default_value }}".toBoolean(), "{{ param.description }}"));
{% endif %}

{% endfor %}

//job.removeProperty(params);
job.setConcurrentBuild(false)
job.addProperty(new BuildDiscarderProperty(new LogRotator ( 7, 1, 7, 1)))
job.addProperty(new ParametersDefinitionProperty(newParams));
job.description="{{ item.description }}"

// Set the branch somehow
job.save()